(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3703,        118]*)
(*NotebookOutlinePosition[      4371,        141]*)
(*  CellTagsIndexPosition[      4327,        137]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Validate", "ObjectName"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Validate",
    FontFamily->"Courier"],
  "[",
  StyleBox["expr",
    FontSlant->"Italic"],
  "] checks that the tensorial expression ",
  StyleBox["expr",
    FontSlant->"Italic"],
  " 1) does not have unknown heads, 2) does not have objects with invalid \
index structure, 3) does have homogeneous free indices, and 4) does not have \
repeated indices."
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Validate",
    FontFamily->"Courier"],
  " has attribute ",
  StyleBox["HoldFirst",
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] It works by detecting recursively the types of \
subexpressions and calling private functions ",
  StyleBox["ValidateTensor",
    FontFamily->"Courier"],
  ", ",
  StyleBox["ValidateCovD",
    FontFamily->"Courier"],
  ", etc.\n\[FilledSmallSquare] ",
  StyleBox["Validate",
    FontFamily->"Courier"],
  " calls the private function ",
  StyleBox["UncatchedValidate",
    FontFamily->"Courier"],
  ", which actually does the job, but does not have a wrapping ",
  StyleBox["Catch",
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] See: ",
  ButtonBox["Section 5.7",
    ButtonData:>{
      FrontEnd`FileName[ {
        ParentDirectory[ ]}, "xTensorRefGuide.nb", CharacterEncoding -> 
        "iso8859-1"], "Validation"},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare] See also: ",
  StyleBox[ButtonBox["ValidateSymbol",
    ButtonData:>{"ValidateSymbol.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ", ",
  StyleBox[ButtonBox["ERROR",
    ButtonData:>{"ERROR.nb", None},
    ButtonStyle->"Hyperlink"],
    FontFamily->"Courier"],
  ".\n\[FilledSmallSquare] New in version 0.\n\[FilledSmallSquare] Last \
update: 26-X-2007 for version 0.9.3 of ",
  StyleBox["xTensor`",
    FontFamily->"Courier"],
  "."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{Automatic, 234}, {57, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 30, 0, 38, "ObjectName"],
Cell[1809, 55, 422, 13, 64, "Usage"],
Cell[2234, 70, 1453, 45, 200, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

